利用C#进行AutoCAD的二次开发(三)

原创 2004年01月05日 11:53:00

                        利用C#进行AutoCAD的二次开发(三)
                                    C#才鸟
   这一讲的主要内容是介绍AutoCAD对象模型,如果你对VBA开发AutoCAD了解的话,这部分内容应该是超简单的。
对象是 AutoCAD ActiveX 接口的主要构造块,每一个显示的对象均精确代表一个 AutoCAD 组件。AutoCAD ActiveX 接口的主要对象有:
• 直线、圆弧、文字和标注等图形对象。
• 线型与标注样式等样式设置对象
• 图层、编组和块等组织结构对象
• 视图与视口等图形显示对象。
• 图形、AutoCAD 应用程序本身也是对象
所有对象的根对象是AutoCAD 应用程序本身,它用AcadApplication类来表示。获得当前运行的AcadApplication对象可以使用上一讲中介绍的方法来得到。AcadApplication对象下有四个子对象构成,分别是:

 AcadPreferences 对象,通过此对象可以访问和设置“选项”对话框中的相关选项
 AcadDocuments对象,它表示AutoCAD 图形
 AcadMenuBar 对象,它表示AutoCAD主菜单栏 (注意不是AcadMenuBars,因为应用程序只有一个主菜单栏)
 AcadMenuGroups对象, 它表示AutoCAD 菜单和工具栏
上面介绍了AutoCAD ActiveX 接口对象模型的大致组成,下面重点介绍AcadDocuments对象,因为大部分的编程都与它有关。首先大家看到它是复数的形式,因此它是当前打开的AutoCAD所有图形的集合,这种对象称为集合对象(呵呵,好像在讲废话)。集合对象有一些比较重要的方法和特性。其中最主要的是:Count特性用于获取集合中的对象个数(从零开始);Item 方法用于获取集合中的任何对象。关于它们的用法我会在下面的例子中介绍。而 AcadDocuments的单数形式AcadDocument表示当前打开的一个AutoCAD图形。AcadDocument对象由以下几个主要对象组成:
 AcadModelSpace 集合和 AcadPaperSpace集合,提供对图形对象(直线、圆、等)的访问
 AcadLayers、AcadLinetypes 和 AcadTextStyles,则提供对非图形对象(图层、线型、文本样式等)的访问
 AcadPlot 对象提供对“打印”对话框中设置的访问,并为应用过程提供了打印图形的各种方法
 AcadUtility 对象提供用户输入和转换函数
图形对象的创建使用Add方法,比如要创建一个圆,就是用AddCircle方法,而非图形对象的创建使用Add方法。
下面通过一个简单的例子来说明上面介绍的内容。这个例子是在AutoCAD中建立一个新的层,然后在该层中画一个红色的圆和一条绿色的直线。这是程序的源代码:(请先把上一讲中生成的interop.AutoCAD.dll 和 AutoCADExample.dll文件包含在工程中)
using System;
using AcadExample;
using AutoCAD;

namespace CircleLine
{
///
/// Class1 的摘要说明。
///
class Class1
{
///
/// 应用程序的主入口点。
///
[STAThread]
static void Main(string[] args)
{
//
// TODO: 在此处添加代码以启动应用程序
//
using(AutoCADConnector connector=new AutoCADConnector()) //连接AutoCAD
{
AcadDocument aDocument=connector.Application.ActiveDocument;
//取得当前AutoCAD活动图形对象
double[] center=new Double[3]{20,20,0};//设置圆心
double radius=20;//设置圆的半径
double[] startPoint=new Double[3]{0,0,0};//设置直线的起点
double[] endPoint=new Double[3]{40,40,0};//设置直线的终点
AcadLayer newLayer=aDocument.Layers.Add("CircleLine");
//创建一个名为CircleLine的新层
aDocument.ActiveLayer=newLayer;//把CircleLine层设置为当前层
AcadCircle circle=aDocument.ModelSpace.AddCircle(center,radius);//加入圆
AcadLine line=aDocument.ModelSpace.AddLine(startPoint,endPoint);//加入直线
circle.color=ACAD_COLOR.acRed;//把圆变为红色
line.color=ACAD_COLOR.acGreen;//把直线变为绿色
connector.Application.Update();//更新显示
for(int i=0;i Console.WriteLine("这是第{0}个对象:{1}",i+1,aDocument.ModelSpace.Item(i)); //遍历当前图形

}
Console.ReadLine();
}
}
}
好了,今天就到这里。


CAD二次开发(C#)第一个例子

个人开发平台:vs2010,win7,CAD2010C#开发CAD的顺序: 1.建立类库 2.添加引用:AcCui.dll,acdbmgd.dll,acmgd.dll;这三个dll在CAD的安装目...
  • bullzerone
  • bullzerone
  • 2017年06月26日 21:21
  • 3379

C#CAD二次开发读取CAD表格数据

Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument; ...
  • pp_fzp
  • pp_fzp
  • 2016年11月01日 11:18
  • 3400

基于Visual C#的AutoCAD开发——实例1 基本例子

实例1 基本例子 1、新建项目启动Visual Studio 2005,新建一个项目,命名为“CAD开发”,如下图所示:2、添加引用添加AutoCAD的引用AutoCAD 2007 Type Libr...
  • xwebsite
  • xwebsite
  • 2010年05月11日 13:56
  • 6015

c#对AutoCAD二次开发

对AutoCAD进行二次开发可以使用:ObjectArx,VBA,VLisp。但在这里不借用它们,而是直接使用C#开发。 有类库和应用程序两种方式:   方法1:vs2010 开发A...
  • yiyihuazi
  • yiyihuazi
  • 2017年04月18日 11:24
  • 2663

CAD C#二次开发 圆和圆弧转Polyline线

//假设现有实体ent Entity ent = item as Entity; //如果实体为圆弧 i...
  • pp_fzp
  • pp_fzp
  • 2016年10月19日 16:09
  • 1713

C#.Net实现AutoCAD块属性提取

C#.Net实现AutoCAD块属性提取本文主要给大家介绍一下SmartSoft中用C#.Net实现AutoCAD块属性提取的方法,并给出实例代码与大家共享。此类实现AutoCAD块属性提取功能,在V...
  • dengyiyu
  • dengyiyu
  • 2008年03月20日 22:00
  • 2486

用C#编写的完整的CAD源码对于初学者很有用的哦!

  • 2008年10月09日 18:22
  • 58KB
  • 下载

用C#编写AutoCAD中的直线

使用C#开发AutoCAD编程基础
  • sanqima
  • sanqima
  • 2014年08月06日 16:14
  • 3539

C#实现简单CAD功能

  • 2016年06月20日 21:34
  • 472KB
  • 下载

C#语言操作ActiveX_automation CAD二次开发实例教程

  • 2011年09月26日 00:47
  • 7.95MB
  • 下载
内容举报
返回顶部
收藏助手
不良信息举报
您举报文章:利用C#进行AutoCAD的二次开发(三)
举报原因:
原因补充:

(最多只允许输入30个字)